<template>
    <q-item class='rounded-borders alert-border' :class="BackgroundClass">
        <q-item-section avatar>
            <q-icon :color="Color" :name="Icon"/>
        </q-item-section>
        <q-item-section>
            <q-item-label> {{ alert.alert.title }}</q-item-label>
            <q-item-label caption>{{ alert.alert.body }}</q-item-label>
        </q-item-section>

        <q-item-section side top>
            <q-item-label caption>{{ TimeStamp }}</q-item-label>
        </q-item-section>
    </q-item>
</template>

<style lang='scss' scoped>
.alert-border {
    border-style: solid;
    border-width: 1px 1px 1px 10px;
}

.border-warning {
    border-color: $warning;
}

.border-positive {
    border-color: $positive;
}


.border-negative {
    border-color: $negative;
}

.border-info {
    border-color: $info;
}


</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {AlertPrincipalResponse} from "src/classLibrary/APIModels/analytics/alertPrincipalResponse";
import {AlertLevels} from "src/classLibrary/Constants";
import {formatRelative} from "date-fns";


@Component
export default class AlertItem extends Vue {
    @Prop() alert!: AlertPrincipalResponse

    get Icon(): string {
        return AlertLevels.Find(x => x.value === this.alert.alert.alertLevel)?.icon ?? "";
    }

    get TimeStamp(): string {
        return formatRelative(new Date(this.alert.timeStamp), new Date());
    }

    get Color(): string {
        switch (this.alert.alert.alertLevel) {
            case "warning":
                return "warning";
            case "success":
                return "positive";
            case "error":
                return "negative";
            case "information":
                return "info";
        }
    }

    get BackgroundClass(): string {
        switch (this.alert.alert.alertLevel) {
            case "warning":
                return " border-warning";
            case "success":
                return "border-positive";
            case "error":
                return " border-negative";
            case "information":
                return "border-info";
        }
    }

}
</script>
